package com.cpp.web.domain.cloud;

import com.baomidou.mybatisplus.annotation.TableName;
import com.cpp.web.domain.BaseCppEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import javax.validation.constraints.Digits;

/**
 * 中心测预测短期
 *
 * @author tl
 * @date 2024-09-23 15:28:33
 */
@Data
@TableName("cpp_forecast_power_short_term_cloud")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "cpp_forecast_power_short_term_cloud")
public class ForecastPowerShortTermCloud extends BaseCppEntity {


    /**
     * 预测时间
     */
    @ApiModelProperty(value = "预测值时间")
    private Date time;


    /**
     * 预测数据
     */
    @ApiModelProperty(value = "预测数据")
    @Digits(integer = 10, fraction = 2)
    private BigDecimal fpValue = new BigDecimal(-99);


    /**
     * 预测厂家
     */
    @ApiModelProperty(value = "预测厂家")
    private String forecastManufacturers;


    /**
     * 预测模型
     */
    @ApiModelProperty(value = "预测模型")
    private String forecastModel;


    /**
     * 提前多久预测
     */
    @ApiModelProperty(value = "提前多久预测")
    private Integer forecastHowLongAgo;


    /**
     * 开机容量
     */
    @ApiModelProperty(value = "开机容量")
    private BigDecimal openCapacity = new BigDecimal(-99);


    /**
     * 装机容量
     */
    @ApiModelProperty(value = "装机容量")
    @Digits(integer = 10, fraction = 2)
    private BigDecimal capacity = new BigDecimal(-99);



}
