package com.cpp.web.domain.datafactory;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * cdq解析配置
 * Parse file
 * @author tl
 * @version 1.0
 */
@Data
@TableName("cpp_parsing_cft")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "cpp_parsing_cft")
public class ParsingCft extends BaseParsing {


    /**
     * 状态值为1代表运行，2代表待机，3代表停用，4代表故障
     */
    @ApiModelProperty(value = "状态值为1代表运行，2代表待机，3代表停用，4代表故障")
    private String status;


    /**
     * 时间
     */
    @ApiModelProperty(value = "时间")
    private String time;


    /**
     * 温度瞬时值
     */
    @ApiModelProperty(value = "温度瞬时值")
    private String tInst;


    /**
     * 湿度瞬时值（%）
     */
    @ApiModelProperty(value = "湿度瞬时值（%）")
    private String rhInst;




    /**
     * 气压瞬时值（KPa）
     */
    @ApiModelProperty(value = "气压瞬时值（KPa）")
    private String paInst;




    /**
     * 10米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "10米风速瞬时值（m/s）")
    private String wsInst10;



    /**
     * 10米风向瞬时值（°）
     */
    @ApiModelProperty(value = "10米风向瞬时值（°）")
    private String wdInst10;



    /**
     * 30米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "30米风速瞬时值（m/s）")
    private String wsInst30;


    /**
     * 30米风向瞬时值（°）
     */
    @ApiModelProperty(value = "30米风向瞬时值（°）")
    private String wdInst30;


    /**
     * 50米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "50米风速瞬时值（m/s）")
    private String wsInst50;


    /**
     * 50米风向瞬时值（°）
     */
    @ApiModelProperty(value = "50米风向瞬时值（°）")
    private String wdInst50;



    /**
     * 60米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "60米风速瞬时值（m/s）")
    private String wsInst60;



    /**
     * 60米风向瞬时值（°）
     */
    @ApiModelProperty(value = "60米风向瞬时值（°）")
    private String wdInst60;



    /**
     * 70米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "70米风速瞬时值（m/s）")
    private String wsInst70;



    /**
     * 70米风向瞬时值（°）
     */
    @ApiModelProperty(value = "70米风向瞬时值（°）")
    private String wdInst70;

    public String gettInst() {
        return tInst;
    }

    public void settInst(String tInst) {
        this.tInst = tInst;
    }

    /**
     * 80米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "80米风速瞬时值（m/s）")
    private String wsInst80;



    /**
     * 80米风向瞬时值（°）
     */
    @ApiModelProperty(value = "80米风向瞬时值（°）")
    private String wdInst80;



    /**
     * 90米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "90米风速瞬时值（m/s）")
    private String wsInst90;



    /**
     * 90米风向瞬时值（°）
     */
    @ApiModelProperty(value = "90米风向瞬时值（°）")
    private String wdInst90;



    /**
     * 100米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "100米风速瞬时值（m/s）")
    private String wsInst100;



    /**
     * 100米风向瞬时值（°）
     */
    @ApiModelProperty(value = "100米风向瞬时值（°）")
    private String wdInst100;



    /**
     * 110米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "110米风速瞬时值（m/s）")
    private String wsInst110;



    /**
     * 110米风向瞬时值（°）
     */
    @ApiModelProperty(value = "110米风向瞬时值（°）")
    private String wdInst110;



    /**
     * 120米风速瞬时值（m/s）
     */
    @ApiModelProperty(value = "120米风速瞬时值（m/s）")
    private String wsInst120;



    /**
     * 120米风向瞬时值（°）
     */
    @ApiModelProperty(value = "120米风向瞬时值（°）")
    private String wdInst120;


    /**
     * 风机轮毂高度风速瞬时值
     */
    @ApiModelProperty(value = "风机轮毂高度风速瞬时值")
    private String wsInstHubHeight;


    /**
     * 风机轮毂高度风向瞬时值（°）
     */
    @ApiModelProperty(value = "风机轮毂高度风向瞬时值（°）")
    private String wdInstHubHeight;


    /**
     * 空气密度  Kg/m³
     */
    @ApiModelProperty(value = "空气密度  Kg/m³")
    private String airDensity;
}
