package com.cpp.web.domain.datafactory;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.cpp.common.core.domain.BaseEntity;
import com.cpp.web.domain.BaseCppEntity;
import com.cpp.web.domain.datafactory.enums.FileTypeEnum;
import com.cpp.web.domain.enums.DataSourcesEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * ftp解析文件
 * Parse file
 *
 * @author tl
 * @version 1.0
 */
@TableName("cpp_parsing_file_url")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "cpp_parsing_file_url")
@Data
public class ParsingFileUrl extends BaseCppEntity {

    /**
     * Id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键ID")
    private Long id;


    /**
     * 解析分类（云端预测，站端上报）
     */
    @ApiModelProperty(value = "解析分类")
    private DataSourcesEnum parsingDataSources;

    /**
     * 文件类型
     */
    @ApiModelProperty(value = "文件类型")
    private FileTypeEnum fileType;

    /**
     * 文件扫描路径
     */
    @ApiModelProperty(value = "文件扫描路径")
    private String url;

}
