package com.cpp.web.domain.datafactory;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * cdq解析配置
 * Parse file
 * @author tl
 * @version 1.0
 */
@Data
@TableName("cpp_parsing_fj")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "cpp_parsing_fj")
public class ParsingFj extends BaseParsing {

    /**
     * 设备名称（该项对应本地设备中的设备名称）
     */
    @ApiModelProperty(value = "设备名称")
    private String equipmentName;


    /**
     * 状态值为1代表运行，2代表待机，3代表停用，4代表故障
     */
    @ApiModelProperty(value = "状态值为1代表运行，2代表待机，3代表停用，4代表故障")
    private String status;


    /**
     * 时间
     */
    @ApiModelProperty(value = "时间")
    private String time;


    /**
     * 有功（KW）
     */
    @ApiModelProperty(value = "有功（KW）")
    private String activePower;


    /**
     * 无功（KVar）
     */
    @ApiModelProperty(value = "无功（KVar）")
    private String reactivePower;


    /**
     * 功率因数
     */
    @ApiModelProperty(value = "功率因数")
    private String powerFactor;


    /**
     * 电压（V）
     */
    @ApiModelProperty(value = "电压（V）")
    private String voltage;


    /**
     * 电流（A）
     */
    @ApiModelProperty(value = "电流（A）")
    private String electricalCurrent;


    /**
     * 当日发电量（kW·h）
     */
    @ApiModelProperty(value = "当日发电量（kW·h）")
    private String dayElectricQuantity;


    /**
     * 当日并网小时
     */
    @ApiModelProperty(value = "当日并网小时")
    private String dayGridConnectedHours;


    /**
     * 转速（rpm）
     */
    @ApiModelProperty(value = "转速（rpm）")
    private String windWheelRatedSpeed;


    /**
     * 风速（m/s）
     */
    @ApiModelProperty(value = "风速（m/s）")
    private String ws;


    /**
     * 风向（°）
     */
    @ApiModelProperty(value = "风向（°）")
    private String wd;


    /**
     * 温度（℃）
     */
    @ApiModelProperty(value = "温度（℃）")
    private String t;


    /**
     * 桨距角（°）
     */
    @ApiModelProperty(value = "桨距角（°）")
    private String pitchAngle;


    /**
     * 累积发电量（MW·h）
     */
    @ApiModelProperty(value = "累积发电量（MW·h）")
    private String cumulativeGeneratedEnergy;
}
