package com.cpp.web.domain.datafactory;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * nwp解析配置
 * Parse file
 * @author tl
 * @version 1.0
 */
@Data
@TableName("cpp_parsing_nwp")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "cpp_parsing_nwp")
public class ParsingNwp extends BaseParsing {


    /**
     * 预测时间
     */
    @ApiModelProperty(value = "预测时间")
    private String preTime;


    /**
     * 生成日期
     */
    @ApiModelProperty(value = "生成日期")
    private String scDate;


    /**
     * 生成时间
     */
    @ApiModelProperty(value = "生成时间")
    private String scTime;


    /**
     * 预测日期
     */
    @ApiModelProperty(value = "预测日期")
    private String preDate;


    /**
     * 温度
     */
    @ApiModelProperty(value = "温度")
    private String t;


    /**
     * 湿度
     */
    @ApiModelProperty(value = "湿度")
    private String rh;


    /**
     * 气压
     */
    @ApiModelProperty(value = "气压")
    private String pressure;


    /**
     * 短波辐射
     */
    @ApiModelProperty(value = "短波辐射")
    private String swr;


    /**
     * 长波辐射
     */
    @ApiModelProperty(value = "长波辐射")
    private String lwr;


    /**
     * 直辐射
     */
    @ApiModelProperty(value = "直辐射")
    private String directRadiation;


    /**
     * 散辐射
     */
    @ApiModelProperty(value = "散辐射")
    private String diffuseRadiation;


    /**
     * 热感通量
     */
    @ApiModelProperty(value = "热感通量")
    private String senf;


    /**
     * 10米风速
     */
    @ApiModelProperty(value = "10米风速")
    private String ws10;


    /**
     * 30米风速
     */
    @ApiModelProperty(value = "30米风速")
    private String ws30;


    /**
     * 50米风速
     */
    @ApiModelProperty(value = "50米风速")
    private String ws50;


    /**
     * 70米风速
     */
    @ApiModelProperty(value = "70米风速")
    private String ws70;


    /**
     * 80米风速
     */
    @ApiModelProperty(value = "80米风速")
    private String ws80;


    /**
     * 90米风速
     */
    @ApiModelProperty(value = "90米风速")
    private String ws90;


    /**
     * 100米风速
     */
    @ApiModelProperty(value = "100米风速")
    private String ws100;


    /**
     * 170米风速
     */
    @ApiModelProperty(value = "170米风速")
    private String ws170;


    /**
     * 10米风向
     */
    @ApiModelProperty(value = "10米风向")
    private String wd10;


    /**
     * 30米风向
     */
    @ApiModelProperty(value = "30米风向")
    private String wd30;


    /**
     * 50米风向
     */
    @ApiModelProperty(value = "50米风向")
    private String wd50;


    /**
     * 70米风向
     */
    @ApiModelProperty(value = "70米风向")
    private String wd70;


    /**
     * 80米风向
     */
    @ApiModelProperty(value = "80米风向")
    private String wd80;


    /**
     * 90米风向
     */
    @ApiModelProperty(value = "90米风向")
    private String wd90;


    /**
     * 100米风向
     */
    @ApiModelProperty(value = "100米风向")
    private String wd100;


    /**
     * 170米风向
     */
    @ApiModelProperty(value = "170米风向")
    private String wd170;

}
