package com.cpp.web.domain.station;

import com.baomidou.mybatisplus.annotation.TableName;
import com.cpp.web.domain.BaseCppEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;

/**
 * cpp_electric_field
 *
 * @author tl
 * @date 2024-09-23 15:28:33
 */
@Data
@TableName("cpp_electric_field")
@EqualsAndHashCode(callSuper = true)
public class ElectricField extends BaseCppEntity {



    /**
     * 电站名称
     */
    @ApiModelProperty(value = "电站名称")
    private String name;


    /**
     * 场站装机容量（MW）
     */
    @ApiModelProperty(value = "场站装机容量（MW）")
    private BigDecimal capacity;


    /**
     * 并网设备数
     */
    @ApiModelProperty(value = "并网设备数")
    private Integer gridCE;


    /**
     * 场站经度
     */
    @ApiModelProperty(value = "场站经度")
    private BigDecimal longitude;


    /**
     * 场站纬度
     */
    @ApiModelProperty(value = "场站纬度")
    private BigDecimal latitude;


    /**
     * 海拔
     */
    @ApiModelProperty(value = "altitude")
    private BigDecimal altitude;


    /**
     * 场站类型1:光伏电站,2:风力电站
     */
    @ApiModelProperty(value = "场站类型1:光伏电站,2:风力电站")
    private String electricFieldTypeEnum;



    /**
     * 场站所属公司
     */
    @ApiModelProperty(value = "场站所属公司")
    private String company;


    /**
     * 场站位置
     */
    @ApiModelProperty(value = "场站位置")
    private String location;


    /**
     * 场站面积
     */
    @ApiModelProperty(value = "场站面积")
    private BigDecimal area;



    /**
     * 上报省调
     */
//    @Enumerated(EnumType.STRING)
    @ApiModelProperty(value = "省份")
    private String provinceEnum;
}
