package com.cpp.web.domain.station;

import com.baomidou.mybatisplus.annotation.TableName;

import com.cpp.web.domain.BaseCppEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.Digits;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * cpp_power_station_status_data
 *
 * @author tl
 * @date 2024-09-23 15:28:33
 */
@Data
@TableName("cpp_power_station_status_data")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "cpp_power_station_status_data")
public class PowerStationStatusData extends BaseCppEntity {


    /**
     * 时间
     */
    @ApiModelProperty(value = "时间")
    private Date time;

    /**
     * 实际功率（MW）
     */
    @ApiModelProperty(value = "实际功率（MW）")
    @Digits(integer = 10, fraction = 2)
    private BigDecimal realValue = new BigDecimal(-99);


    /**
     * 可用功率（MW）
     */
    @ApiModelProperty(value = "可用功率（MW）")
    @Digits(integer = 10, fraction = 2)
    private BigDecimal ableValue = new BigDecimal(-99);


    /**
     * 理论功率（MW）
     */
    @ApiModelProperty(value = "理论功率（MW）")
    @Digits(integer = 10, fraction = 2)
    private BigDecimal theoryValue = new BigDecimal(-99);

    /**
     * 开机容量
     */
    @ApiModelProperty(value = "开机容量")
    @Digits(integer = 10, fraction = 2)
    private BigDecimal openCapacity = new BigDecimal(-99);


    /**
     * 装机容量（MW）
     */
    @ApiModelProperty(value = "装机容量（MW）")
    @Digits(integer = 10, fraction = 2)
    private BigDecimal capacity = new BigDecimal(-99);

    /**
     * 站内受阻容量(故障/检修)（MW）
     */
    @ApiModelProperty(value = "受阻容量（故障/检修）（MW）")
    @Digits(integer = 10, fraction = 2)
    private BigDecimal blockedCapacity = new BigDecimal(-99);


    /**
     * 限电标记
     */
    @ApiModelProperty(value = "限电标记 0不限电 1限电（MW）")
    private Integer powerRationing = 0;


}
