package com.cpp.web.service.cloud;

import com.baomidou.mybatisplus.extension.service.IService;
import com.cpp.web.domain.cloud.ForecastPowerShortTermCloud;

import java.util.Date;
import java.util.List;

/**
 * idp_forecast_power_short_term
 *
 * @author tl
 * @date 2024-09-23 15:28:33
 */
public interface ForecastPowerShortTermCloudService extends IService<ForecastPowerShortTermCloud> {
    /**
     * 根据场站编号和时间范围来查询
     *
     * @param stationCode 场站编号
     * @param startTime   开始时间
     * @param endTime     结束时间
     * @return
     */
    List<ForecastPowerShortTermCloud> findByStationCodeAndStartTimeAndEndTime(String stationCode, Date startTime, Date endTime);

    List<ForecastPowerShortTermCloud> findByStationCodeAndStartTimeAndEndTimeAndForecastManufactor(String stationCode, Date startTime, Date endTime, String forecastManufactor);}
