package com.cpp.web.service.station;

import com.baomidou.mybatisplus.extension.service.IService;
import com.cpp.web.domain.station.ForecastPowerUltraShortTermStation;

import java.util.Date;
import java.util.List;

/**
 * cpp_forecast_power_ultra_short_term_his
 *
 * @author tl
 * @date 2024-09-23 15:28:33
 */
public interface ForecastPowerUltraShortTermStationService extends IService<ForecastPowerUltraShortTermStation> {
    /**
     * 根据场站编号和时间范围来查询
     *
     * @param stationCode        场站编号
     * @param startTime          开始时间
     * @param endTime            结束时间
     * @param cdqPoint           超短期点位
     * @param forecastManufactor 预测厂家
     * @return
     */
    List<ForecastPowerUltraShortTermStation> findByStationCodeAndStartTimeAndEndTimeAndHowLongAgoAndForecastManufactor(String stationCode, Date startTime, Date endTime, Integer cdqPoint, String forecastManufactor);

    List<ForecastPowerUltraShortTermStation> findByForecastTimeBetweenAndForecastHowLongAgoAndStationCode(Long startTime, Long endTime, Integer howLongAgo, String stationCode);

    List<ForecastPowerUltraShortTermStation> findByForecastTimeAndStationCode(Long finalTime, String stationCode);
}
