package com.cpp.web.service.station;

import com.baomidou.mybatisplus.extension.service.IService;
import com.cpp.web.domain.station.PowerStationStatusData;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * cpp_power_station_status_data
 *
 * @author tl
 * @date 2024-09-23 15:28:33
 */
public interface PowerStationStatusDataService extends IService<PowerStationStatusData> {
    /**
     * 根据场站编号和时间范围来查询
     *
     * @param stationCode 场站编号
     * @param startTime   开始时间
     * @param endTime     结束时间
     * @return
     */
    List<PowerStationStatusData> findByStationCodeAndStartTimeAndEndTime(String stationCode, Date startTime, Date endTime);

    List<ArrayList<String>> timeStamp(Date startTime, Date endTime) throws ParseException;

    Map<String, List> getCompositeData(String stationCode, Date startTime, Date endTime, String forecastManufactor, Integer cdqPoint, Integer dqPoint);
    Map<String, List> getCenterData(Date startTime, Date endTime);

    List<PowerStationStatusData> findByTimeBetweenAndStationCode(Date pointStarTime, Date pointEndTime, String stationCode);
}
